SystemOrganization addCategory: #Metaprogramacion!

TestCase subclass: #FinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!FinderTests methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 19:00'!
test01lookForMissingImplementorsShouldFailIfClassCantUnderstandIt
	self should: [AbstractTestClass1 lookForMissingImplementors: #methodNotUnderstood]
		raise: Error
		withExceptionDo: [ :anError | anError description = 'Error: El metodo no pertenece a la clase']! !

!FinderTests methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 19:00'!
test02shouldReturnNoClassesIfSuperClassDontHaveSubclasses
	| missingImplementors |
	missingImplementors := AbstractTestClass2 lookForMissingImplementors: #abstractMethod.
	self assert: missingImplementors size = 0.! !

!FinderTests methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 19:13'!
test03shouldReturnConcreteSubclassesIfThereIsNoImplementationOfAbstractMethod
	| missingImplementors |
	missingImplementors := AbstractTestClass13 lookForMissingImplementors: #abstractMethod.
	self assert: (missingImplementors includes: ConcretTestClass131).
	self assert: missingImplementors size = 1.! !

Object subclass: #AbstractTestClass1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractTestClass1 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:37'!
abstractMethod
	^self subclassResponsibility ! !

AbstractTestClass1 subclass: #AbstractTestClass12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractTestClass12 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:18'!
abstractMethod
	^self subclassResponsibility ! !

AbstractTestClass12 subclass: #ConcreteTestClass121
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteTestClass121 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:24'!
abstractMethod
	^nil! !

AbstractTestClass1 subclass: #AbstractTestClass13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractTestClass13 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:38'!
abstractMethod
	^self subclassResponsibility ! !

AbstractTestClass13 subclass: #ConcretTestClass131
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

AbstractTestClass13 subclass: #ConcretTestClass132
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcretTestClass132 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 19:11'!
abstractMethod
	^nil! !

Object subclass: #AbstractTestClass2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractTestClass2 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:39'!
abstractMethod
	^self subclassResponsibility ! !
